Status: Closed Start date:  
Assignee: Go MAEDA % Done: 0%

Category: Importers Estimated time: 0.00 hour

Target version:    

Resolution: Fixed Affected version:  

Description

To reproduce the error, attempt to import issues from the attached csv file (issues.csv). In the CSV file, the second column of the

header is blank.

You will see an error page after clicking the "Next" button on the import options page.

Started GET "/imports/ad8c66039d97b44886137856ade5f856/mapping" for 127.0.0.1 at 2020-11-27 14:51:

09 +0900

Processing by ImportsController#mapping as HTML

  Parameters: {"id"=>"ad8c66039d97b44886137856ade5f856"}

.

.

.

NoMethodError (undefined method `downcase' for nil:NilClass):

app/controllers/imports_controller.rb:177:in `map'

app/controllers/imports_controller.rb:177:in `auto_map_fields'

app/controllers/imports_controller.rb:70:in `mapping'

lib/redmine/sudo_mode.rb:61:in `sudo_mode'

Related issues:

Related to Redmine - Feature #22913: Auto-select fields mapping in Importing Closed

Associated revisions

Revision 20576 - 2020-12-05 01:21 - Go MAEDA

CSV import raises an exception if CSV header has empty columns (#22913, #34326).

History

#1 - 2020-11-27 06:58 - Go MAEDA

- Related to Feature #22913: Auto-select fields mapping in Importing added

#2 - 2020-11-30 08:42 - Yuichi HARADA

- File fixed-34326.patch added

I created a patch. No exception is raised if there are blank columns in the CSV header.

diff --git a/app/controllers/imports_controller.rb b/app/controllers/imports_controller.rb

index 9431ca098..a5248dc1e 100644

--- a/app/controllers/imports_controller.rb

+++ b/app/controllers/imports_controller.rb

@@ -173,7 +173,7 @@ class ImportsController < ApplicationController

     return if @import.settings['encoding'].blank?

     mappings = @import.settings['mapping'] ||= {}

-    headers = @import.headers.map(&:downcase)

+    headers = @import.headers.map{|header| header.to_s.downcase}

     # Core fields

     import_type::AUTO_MAPPABLE_FIELDS.each do |field_nm, label_nm|
#3 - 2020-12-03 15:12 - Go MAEDA

- File 34326-v2.patch added

Yuichi HARADA wrote:

I created a patch. No exception is raised if there are blank columns in the CSV header.

[...]

 Thank you for the patch. I think the test can be simplified by putting the blank column at the end.

#4 - 2020-12-04 01:11 - Yuichi HARADA

Go MAEDA wrote:

Yuichi HARADA wrote:

I created a patch. No exception is raised if there are blank columns in the CSV header.

[...]

 Thank you for the patch. I think the test can be simplified by putting the blank column at the end.

 Thank you for your point. I think it's good because you can detect test failures without changing the test.

#5 - 2020-12-04 07:57 - Go MAEDA

- Target version set to 4.2.0

Setting the target version to 4.2.0.

#6 - 2020-12-05 01:21 - Go MAEDA

- Subject changed from CSV import raises an exception if CSV header has blank columns to CSV import raises an exception if CSV header has empty

columns

- Assignee set to Go MAEDA

- Target version deleted (4.2.0)

- Resolution set to Fixed

Committed the fix as a part of #22913. Thank you.

#7 - 2020-12-05 03:17 - Go MAEDA

- Status changed from New to Closed

Files

issues.csv 499 Bytes 2020-11-27 Go MAEDA

fixed-34326.patch 3.6 KB 2020-11-30 Yuichi HARADA

34326-v2.patch 1.32 KB 2020-12-03 Go MAEDA
